/*
 Peripheral View Magic for LPC17xx
 Ver.0.1 (2010/08)

 Copyright (c) 2010, audin
 All rights reserved.

 http://avr.paslog.jp
 

This code is licensed under the BSD License.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditionsare met:

1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

3. Neither the name of the copyright holders nor the names of its
   contributors may be used to endorse or promote products derived from
   this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
THE POSSIBILITY OF SUCH DAMAGE.
*/



#include "LPC17xx.h"

#define PRE_TYPE1 volatile
#define PRE_TYPE2 const

#define IO_VIEW_ALL



//#define IO_SC_EN
//#define IO_GPIO0_EN
//#define IO_GPIO1_EN
//#define IO_GPIO2_EN
//#define IO_GPIO3_EN
//#define IO_GPIO4_EN
//#define IO_WDT_EN
//#define IO_TIM0_EN
//#define IO_TIM1_EN
//#define IO_TIM2_EN
//#define IO_TIM3_EN
//#define IO_RIT_EN
//#define IO_UART0_EN
//#define IO_UART1_EN
//#define IO_UART2_EN
//#define IO_UART3_EN
//#define IO_PWM1_EN
//#define IO_I2C0_EN
//#define IO_I2C1_EN
//#define IO_I2C2_EN
//#define IO_I2S_EN
//#define IO_SPI_EN
//#define IO_RTC_EN
//#define IO_GPIOINT_EN
//#define IO_PINCON_EN
//#define IO_SSP0_EN
//#define IO_SSP1_EN
//#define IO_ADC_EN
//#define IO_DAC_EN
//#define IO_CANAF_EN
//#define IO_CANCR_EN
//#define IO_CAN1_EN
//#define IO_CAN2_EN
//#define IO_MCPWM_EN
//#define IO_QEI_EN
//#define IO_EMAC_EN
//#define IO_GPDMA_EN
//#define IO_GPDMACH0_EN
//#define IO_GPDMACH1_EN
//#define IO_GPDMACH2_EN
//#define IO_GPDMACH3_EN
//#define IO_GPDMACH4_EN
//#define IO_GPDMACH5_EN
//#define IO_GPDMACH6_EN
//#define IO_GPDMACH7_EN
//#define IO_USB_EN


/*----------------------------------------------------------*/


/*------------- General Purpose Input/Output (GPIO) --------------------------*/
typedef struct
{
  union {
    __IO uint32_t FIODIR;
    struct {
      __IO uint16_t FIODIRL;
      __IO uint16_t FIODIRH;
    } FDIR16;
    struct {
      __IO uint8_t  FIODIR0;
      __IO uint8_t  FIODIR1;
      __IO uint8_t  FIODIR2;
      __IO uint8_t  FIODIR3;
    } FDIR8;
  } FDIR;
  uint32_t RESERVED0[3];
  union {
    __IO uint32_t FIOMASK;
    struct {
      __IO uint16_t FIOMASKL;
      __IO uint16_t FIOMASKH;
    } FMASK16;
    struct {
      __IO uint8_t  FIOMASK0;
      __IO uint8_t  FIOMASK1;
      __IO uint8_t  FIOMASK2;
      __IO uint8_t  FIOMASK3;
    } FMASK8;
  } FMASK;
  union {
    __IO uint32_t FIOPIN;
    struct {
      __IO uint16_t FIOPINL;
      __IO uint16_t FIOPINH;
    } FPIN16;
    struct {
      __IO uint8_t  FIOPIN0;
      __IO uint8_t  FIOPIN1;
      __IO uint8_t  FIOPIN2;
      __IO uint8_t  FIOPIN3;
    } FPIN8;
  } FPIN;
  union {
    __IO uint32_t FIOSET;
    struct {
      __IO uint16_t FIOSETL;
      __IO uint16_t FIOSETH;
    } FSET16;
    struct {
      __IO uint8_t  FIOSET0;
      __IO uint8_t  FIOSET1;
      __IO uint8_t  FIOSET2;
      __IO uint8_t  FIOSET3;
    } FSET8;
  } FSET;
  union {
    __O  uint32_t FIOCLR;
    struct {
      __O  uint16_t FIOCLRL;
      __O  uint16_t FIOCLRH;
    } FCLR16;
    struct {
      __O  uint8_t  FIOCLR0;
      __O  uint8_t  FIOCLR1;
      __O  uint8_t  FIOCLR2;
      __O  uint8_t  FIOCLR3;
    } FCLR8;
  } FCLR;
} LPC_GPIO_TypeDef_n;


/*------------- Universal Asynchronous Receiver Transmitter (UART) -----------*/
typedef struct
{
  union {
  __I  uint8_t  RBR;
  __O  uint8_t  THR;
  __IO uint8_t  DLL;
       uint32_t RESERVED0;
  } RBR_THR_DLL;
  union {
  __IO uint8_t  DLM;
  __IO uint32_t IER;
  } DLM_IER;
  union {
  __I  uint32_t IIR;
  __O  uint8_t  FCR;
  } IIR_FCR;
  __IO uint8_t  LCR;
       uint8_t  RESERVED1[7];
  __I  uint8_t  LSR;
       uint8_t  RESERVED2[7];
  __IO uint8_t  SCR;
       uint8_t  RESERVED3[3];
  __IO uint32_t ACR;
  __IO uint8_t  ICR;
       uint8_t  RESERVED4[3];
  __IO uint8_t  FDR;
       uint8_t  RESERVED5[7];
  __IO uint8_t  TER;
       uint8_t  RESERVED6[39];
  __I  uint8_t  FIFOLVL;
} LPC_UART_TypeDef_n;


typedef struct
{
  union {
  __I  uint8_t  RBR;
  __O  uint8_t  THR;
  __IO uint8_t  DLL;
       uint32_t RESERVED0;
  } RBR_THR_DLL;
  union {
  __IO uint8_t  DLM;
  __IO uint32_t IER;
  } DLM_IER;
  union {
  __I  uint32_t IIR;
  __O  uint8_t  FCR;
  } IIR_FCR;
  __IO uint8_t  LCR;
       uint8_t  RESERVED1[7];
  __I  uint8_t  LSR;
       uint8_t  RESERVED2[7];
  __IO uint8_t  SCR;
       uint8_t  RESERVED3[3];
  __IO uint32_t ACR;
  __IO uint8_t  ICR;
       uint8_t  RESERVED4[3];
  __IO uint8_t  FDR;
       uint8_t  RESERVED5[7];
  __IO uint8_t  TER;
       uint8_t  RESERVED6[39];
  __I  uint8_t  FIFOLVL;
} LPC_UART0_TypeDef_n;

typedef struct
{
  union {
  __I  uint8_t  RBR;
  __O  uint8_t  THR;
  __IO uint8_t  DLL;
       uint32_t RESERVED0;
  } RBR_THR_DLL;
  union {
  __IO uint8_t  DLM;
  __IO uint32_t IER;
  } DLM_IER;
  union {
  __I  uint32_t IIR;
  __O  uint8_t  FCR;
  } IIR_FCR;
  __IO uint8_t  LCR;
       uint8_t  RESERVED1[3];
  __IO uint8_t  MCR;
       uint8_t  RESERVED2[3];
  __I  uint8_t  LSR;
       uint8_t  RESERVED3[3];
  __I  uint8_t  MSR;
       uint8_t  RESERVED4[3];
  __IO uint8_t  SCR;
       uint8_t  RESERVED5[3];
  __IO uint32_t ACR;
       uint32_t RESERVED6;
  __IO uint32_t FDR;
       uint32_t RESERVED7;
  __IO uint8_t  TER;
       uint8_t  RESERVED8[27];
  __IO uint8_t  RS485CTRL;
       uint8_t  RESERVED9[3];
  __IO uint8_t  ADRMATCH;
       uint8_t  RESERVED10[3];
  __IO uint8_t  RS485DLY;
       uint8_t  RESERVED11[3];
  __I  uint8_t  FIFOLVL;
} LPC_UART1_TypeDef_n;


/*------------- Universal Serial Bus (USB) -----------------------------------*/
typedef struct
{
  __I  uint32_t HcRevision;             /* USB Host Registers                 */
  __IO uint32_t HcControl;
  __IO uint32_t HcCommandStatus;
  __IO uint32_t HcInterruptStatus;
  __IO uint32_t HcInterruptEnable;
  __IO uint32_t HcInterruptDisable;
  __IO uint32_t HcHCCA;
  __I  uint32_t HcPeriodCurrentED;
  __IO uint32_t HcControlHeadED;
  __IO uint32_t HcControlCurrentED;
  __IO uint32_t HcBulkHeadED;
  __IO uint32_t HcBulkCurrentED;
  __I  uint32_t HcDoneHead;
  __IO uint32_t HcFmInterval;
  __I  uint32_t HcFmRemaining;
  __I  uint32_t HcFmNumber;
  __IO uint32_t HcPeriodicStart;
  __IO uint32_t HcLSTreshold;
  __IO uint32_t HcRhDescriptorA;
  __IO uint32_t HcRhDescriptorB;
  __IO uint32_t HcRhStatus;
  __IO uint32_t HcRhPortStatus1;
  __IO uint32_t HcRhPortStatus2;
       uint32_t RESERVED0[40];
  __I  uint32_t Module_ID;

  __I  uint32_t OTGIntSt;               /* USB On-The-Go Registers            */
  __IO uint32_t OTGIntEn;
  __O  uint32_t OTGIntSet;
  __O  uint32_t OTGIntClr;
  __IO uint32_t OTGStCtrl;
  __IO uint32_t OTGTmr;
       uint32_t RESERVED1[58];

  __I  uint32_t USBDevIntSt;            /* USB Device Interrupt Registers     */
  __IO uint32_t USBDevIntEn;
  __O  uint32_t USBDevIntClr;
  __O  uint32_t USBDevIntSet;

  __O  uint32_t USBCmdCode;             /* USB Device SIE Command Registers   */
  __I  uint32_t USBCmdData;

  __I  uint32_t USBRxData;              /* USB Device Transfer Registers      */
  __O  uint32_t USBTxData;
  __I  uint32_t USBRxPLen;
  __O  uint32_t USBTxPLen;
  __IO uint32_t USBCtrl;
  __O  uint32_t USBDevIntPri;

  __I  uint32_t USBEpIntSt;             /* USB Device Endpoint Interrupt Regs */
  __IO uint32_t USBEpIntEn;
  __O  uint32_t USBEpIntClr;
  __O  uint32_t USBEpIntSet;
  __O  uint32_t USBEpIntPri;

  __IO uint32_t USBReEp;                /* USB Device Endpoint Realization Reg*/
  __O  uint32_t USBEpInd;
  __IO uint32_t USBMaxPSize;

  __I  uint32_t USBDMARSt;              /* USB Device DMA Registers           */
  __O  uint32_t USBDMARClr;
  __O  uint32_t USBDMARSet;
       uint32_t RESERVED2[9];
  __IO uint32_t USBUDCAH;
  __I  uint32_t USBEpDMASt;
  __O  uint32_t USBEpDMAEn;
  __O  uint32_t USBEpDMADis;
  __I  uint32_t USBDMAIntSt;
  __IO uint32_t USBDMAIntEn;
       uint32_t RESERVED3[2];
  __I  uint32_t USBEoTIntSt;
  __O  uint32_t USBEoTIntClr;
  __O  uint32_t USBEoTIntSet;
  __I  uint32_t USBNDDRIntSt;
  __O  uint32_t USBNDDRIntClr;
  __O  uint32_t USBNDDRIntSet;
  __I  uint32_t USBSysErrIntSt;
  __O  uint32_t USBSysErrIntClr;
  __O  uint32_t USBSysErrIntSet;
       uint32_t RESERVED4[15];

  __I  uint32_t I2C_RX;                 /* USB OTG I2C Registers              */
  __O  uint32_t I2C_WO;
  __I  uint32_t I2C_STS;
  __IO uint32_t I2C_CTL;
  __IO uint32_t I2C_CLKHI;
  __O  uint32_t I2C_CLKLO;
       uint32_t RESERVED5[823];

  union {
  __IO uint32_t USBClkCtrl;             /* USB Clock Control Registers        */
  __IO uint32_t OTGClkCtrl;
  } USB_OTG_CLK_CTL;
  union {
  __I  uint32_t USBClkSt;
  __I  uint32_t OTGClkSt;
  } USB_OTG_CLK_ST;
} LPC_USB_TypeDef_n;




/*----------------------------------------------------------*/

#if defined( IO_SC_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_SC_TypeDef * PRE_TYPE2 IO_SC = LPC_SC;
#endif

#if defined( IO_GPIO0_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_GPIO_TypeDef_n * PRE_TYPE2 IO_GPIO0 = (LPC_GPIO_TypeDef_n *)LPC_GPIO0;
#endif

#if defined( IO_GPIO1_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_GPIO_TypeDef_n * PRE_TYPE2 IO_GPIO1 = (LPC_GPIO_TypeDef_n *)LPC_GPIO1;
#endif

#if defined( IO_GPIO2_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_GPIO_TypeDef_n * PRE_TYPE2 IO_GPIO2 = (LPC_GPIO_TypeDef_n *)LPC_GPIO2;
#endif

#if defined( IO_GPIO3_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_GPIO_TypeDef_n * PRE_TYPE2 IO_GPIO3 = (LPC_GPIO_TypeDef_n *)LPC_GPIO3;
#endif

#if defined( IO_GPIO4_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_GPIO_TypeDef_n * PRE_TYPE2 IO_GPIO4 = (LPC_GPIO_TypeDef_n *)LPC_GPIO4;
#endif

#if defined( IO_WDT_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_WDT_TypeDef * PRE_TYPE2 IO_WDT = LPC_WDT;
#endif

#if defined( IO_TIM0_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_TIM_TypeDef * PRE_TYPE2 IO_TIM0 = LPC_TIM0;
#endif

#if defined( IO_TIM1_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_TIM_TypeDef * PRE_TYPE2 IO_TIM1 = LPC_TIM1;
#endif

#if defined( IO_TIM2_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_TIM_TypeDef * PRE_TYPE2 IO_TIM2 = LPC_TIM2;
#endif

#if defined( IO_TIM3_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_TIM_TypeDef * PRE_TYPE2 IO_TIM3 = LPC_TIM3;
#endif

#if defined( IO_RIT_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_RIT_TypeDef * PRE_TYPE2 IO_RIT = LPC_RIT;
#endif

#if defined( IO_UART0_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_UART0_TypeDef_n * PRE_TYPE2 IO_UART0 = (LPC_UART0_TypeDef_n *)LPC_UART0;
#endif

#if defined( IO_UART1_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_UART1_TypeDef_n * PRE_TYPE2 IO_UART1 = (LPC_UART1_TypeDef_n *)LPC_UART1;
#endif

#if defined( IO_UART2_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_UART_TypeDef_n * PRE_TYPE2 IO_UART2 = (LPC_UART_TypeDef_n *)LPC_UART2;
#endif

#if defined( IO_UART3_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_UART_TypeDef_n * PRE_TYPE2 IO_UART3 = (LPC_UART_TypeDef_n *)LPC_UART3;
#endif

#if defined( IO_PWM1_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_PWM_TypeDef * PRE_TYPE2 IO_PWM1 = LPC_PWM1;
#endif

#if defined( IO_I2C0_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_I2C_TypeDef * PRE_TYPE2 IO_I2C0 = LPC_I2C0;
#endif

#if defined( IO_I2C1_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_I2C_TypeDef * PRE_TYPE2 IO_I2C1 = LPC_I2C1;
#endif

#if defined( IO_I2C2_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_I2C_TypeDef * PRE_TYPE2 IO_I2C2 = LPC_I2C2;
#endif

#if defined( IO_I2S_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_I2S_TypeDef * PRE_TYPE2 IO_I2S = LPC_I2S;
#endif

#if defined( IO_SPI_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_SPI_TypeDef * PRE_TYPE2 IO_SPI = LPC_SPI;
#endif

#if defined( IO_RTC_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_RTC_TypeDef * PRE_TYPE2 IO_RTC = LPC_RTC;
#endif

#if defined( IO_GPIOINT_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_GPIOINT_TypeDef * PRE_TYPE2 IO_GPIOINT = LPC_GPIOINT;
#endif

#if defined( IO_PINCON_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_PINCON_TypeDef * PRE_TYPE2 IO_PINCON = LPC_PINCON;
#endif

#if defined( IO_SSP0_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_SSP_TypeDef * PRE_TYPE2 IO_SSP0 = LPC_SSP0;
#endif

#if defined( IO_SSP1_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_SSP_TypeDef * PRE_TYPE2 IO_SSP1 = LPC_SSP1;
#endif

#if defined( IO_ADC_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_ADC_TypeDef * PRE_TYPE2 IO_ADC = LPC_ADC;
#endif

#if defined( IO_DAC_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_DAC_TypeDef * PRE_TYPE2 IO_DAC = LPC_DAC;
#endif

#if defined( IO_CANAF_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_CANAF_TypeDef * PRE_TYPE2 IO_CANAF = LPC_CANAF;
#endif

#if defined( IO_CANCR_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_CANCR_TypeDef * PRE_TYPE2 IO_CANCR = LPC_CANCR;
#endif

#if defined( IO_CAN1_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_CAN_TypeDef * PRE_TYPE2 IO_CAN1 = LPC_CAN1;
#endif

#if defined( IO_CAN2_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_CAN_TypeDef * PRE_TYPE2 IO_CAN2 = LPC_CAN2;
#endif

#if defined( IO_MCPWM_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_MCPWM_TypeDef * PRE_TYPE2 IO_MCPWM = LPC_MCPWM;
#endif

#if defined( IO_QEI_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_QEI_TypeDef * PRE_TYPE2 IO_QEI = LPC_QEI;
#endif

#if defined( IO_EMAC_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_EMAC_TypeDef * PRE_TYPE2 IO_EMAC = LPC_EMAC;
#endif

#if defined( IO_GPDMA_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_GPDMA_TypeDef * PRE_TYPE2 IO_GPDMA = LPC_GPDMA;
#endif

#if defined( IO_GPDMACH0_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_GPDMACH_TypeDef * PRE_TYPE2 IO_GPDMACH0 = LPC_GPDMACH0;
#endif

#if defined( IO_GPDMACH1_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_GPDMACH_TypeDef * PRE_TYPE2 IO_GPDMACH1 = LPC_GPDMACH1;
#endif

#if defined( IO_GPDMACH2_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_GPDMACH_TypeDef * PRE_TYPE2 IO_GPDMACH2 = LPC_GPDMACH2;
#endif

#if defined( IO_GPDMACH3_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_GPDMACH_TypeDef * PRE_TYPE2 IO_GPDMACH3 = LPC_GPDMACH3;
#endif

#if defined( IO_GPDMACH4_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_GPDMACH_TypeDef * PRE_TYPE2 IO_GPDMACH4 = LPC_GPDMACH4;
#endif

#if defined( IO_GPDMACH5_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_GPDMACH_TypeDef * PRE_TYPE2 IO_GPDMACH5 = LPC_GPDMACH5;
#endif

#if defined( IO_GPDMACH6_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_GPDMACH_TypeDef * PRE_TYPE2 IO_GPDMACH6 = LPC_GPDMACH6;
#endif

#if defined( IO_GPDMACH7_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_GPDMACH_TypeDef * PRE_TYPE2 IO_GPDMACH7 = LPC_GPDMACH7;
#endif

#if defined( IO_USB_EN ) || defined( IO_VIEW_ALL )
	PRE_TYPE1 LPC_USB_TypeDef_n * PRE_TYPE2 IO_USB = (LPC_USB_TypeDef_n *)LPC_USB;
#endif



/*-------------------------- end --------------------------------*/

