/*
 Copyright (c) 2010, audin
 All rights reserved.

 http://avr.paslog.jp
 2010/08

This code is licensed under the BSD License.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditionsare met:

1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

3. Neither the name of the copyright holders nor the names of its
   contributors may be used to endorse or promote products derived from
   this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
THE POSSIBILITY OF SUCH DAMAGE.
*/

typedef volatile union PLL0STAT_t {
	uint32_t reg;
	struct {
		__I		uint32_t MSEL0 :	15;
				uint32_t rsv0 :		 1;
		__I		uint32_t NSEL0 :	 8;
		__I		uint32_t OLLE0_STAT :1;
		__I		uint32_t PLLC0_STAT :1;
		__I		uint32_t PLOCK0 :	 1;
				uint32_t rsv1 :		 5;
	} b;
} *PLL0STAT_p;

typedef volatile union CLKOUTCFG_t {
	uint32_t reg;
	struct {
		__IO	uint32_t CLKOUTSEL:	4;
		__IO	uint32_t CLKOUTDIV:	4;
		__IO 	uint32_t CLKOUT_EN:	1;
		__I		uint32_t CLKOUT_ACT:1;
				uint32_t resv0:		22;
	} b;
} *CLKOUTCFG_p;






/*-------------------------------------------------------------------*/
// Usage:
//
// PLL0STAT_p	PLL0STAT_	= (PLL0STAT_p)	0x400fC088;
// CLKOUTCFG_p	CLKOUTCFG_	= (CLKOUTCFG_p)	&LPC_SC->CLKOUTCFG;



