$Input_File="LPC17xx.h"
$Output_File="LPC17xx_io_view.c"

def BSDL(fp)
fp.print <<-EOS
/*
 Peripheral View Magic for LPC17xx
 Ver.0.1 (2010/08)

 Copyright (c) 2010, audin
 All rights reserved.

 http://avr.paslog.jp
 

This code is licensed under the BSD License.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditionsare met:

1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

3. Neither the name of the copyright holders nor the names of its
   contributors may be used to endorse or promote products derived from
   this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
THE POSSIBILITY OF SUCH DAMAGE.
*/


EOS
end

class Ioview
	
	def initialize(headerFile,outFile)
		@baseAddrs=""
		@typeDef=""
		@info=[]
		@headerFile = headerFile
		@pretype1="PRE_TYPE1"
		@pretype1_in="volatile"
		@pretype2="PRE_TYPE2"
		@pretype2_in="const"
		@ofp = open(outFile,"w")
	end
	
	def header_top
		#@ofp.puts "#ifndef _LPC17XX_IO_VIEW_H_"
		#@ofp.puts "#define _LPC17XX_IO_VIEW_H_"
		@ofp.puts "#define #{@pretype1} #{@pretype1_in}"
		@ofp.puts "#define #{@pretype2} #{@pretype2_in}"
	end
	
	def header_end
		@ofp.puts "#endif   /* _LPC17XX_IO_VIEW_H_ */"
	end
	
	def exe
		BSDL(@ofp)
		open(@headerFile).each do | line |
			if (line =~ /\#define /) && (line.split.size >=6 ) && (line.split[5]==")" ) then			
				@baseAddrs = line.split[1]
				@typeDef   = line.split[2].gsub(/\(/,"")
				@info << [@baseAddrs, @typeDef]
			end
		end		
		@ofp.print "\n\#include \"LPC17xx.h\"\n\n"
		header_top()
		@ofp.print "\n\#define IO_VIEW_ALL\n\n"
		@ofp.print "\n\n"
		@info.each do | base, type |
			@ofp.puts "\//#define #{base.gsub(/LPC_/,"IO_")}_EN"
		end
		sepa
		open("io_view_alt.h").each do | line|
			@ofp.puts line
		end
		sepa
		@info.each do | base,type |
			type_t = type
			cast =""
			if base =~ /GPIO[0-4]|UART|USB/ then
				type_t += "_n"
				cast   = "(#{type_t} *)"
			end
			io_base = base.gsub(/LPC_/,"IO_")
			@ofp.puts "\#if defined( #{io_base}_EN ) || defined( IO_VIEW_ALL )"
			@ofp.puts "\t#{@pretype1 +" "+ type_t} * #{@pretype2 +" "+io_base} = #{cast + base};"
			@ofp.puts "\#endif"
			@ofp.puts
		end
		sepa(" end ")

		#header_end()
		@ofp.close
	end
	
	def addinc	
@ofp.print <<-EOS
#include "io_view_bits.h"

		EOS
	end
	
	def sepa(str="")
		@ofp.print "\n\n/*--------------------------#{str}--------------------------------*/\n\n"
	end	
end


Ioview.new($Input_File,$Output_File).exe
